/*
feladat:
P//szumma Ci
*/

package gyak_2;

import java.util.ArrayList;

/**
 *
 * @author Simon Csaba
 */
public class Main_2
{
	public static void main(String[] args)
	{
		int N = 5; //jobok száma
		int M = 2; //gépek száma
		int Pmax = 300;
		int fiktiv;		
		ArrayList<Job> jobok = new ArrayList<Job>();
		Gep[] gepek = new Gep[M];
		int i,j; //segédváltozók
		int tempP;
		Job tempJob = null;
		int csoportSzam;
		int db; //job/csoport
		int szumC = 0;


		//gépek hozzáadása
		for(i=0; i<M; i++)
		{
			gepek[i] = new Gep(i);
		}

		//jobok hozzáadása
		for(i=0; i<N; i++)
		{
			tempP = (int)((Pmax-1) * Math.random() + 1);
			jobok.add(new Job(i, tempP));
		}

		/*órai példa 5 job, 2 gép
		jobok.add(new Job(1, 10));
		jobok.add(new Job(2, 20));
		jobok.add(new Job(3, 15));
		jobok.add(new Job(4, 5));
		jobok.add(new Job(5, 25));*/

		//jobok sorbarendezése P alapján
		for(i=0; i<N-1; i++)
		{
			for (j = i+1; j<N; j++ )
			{
				if(jobok.get(i).getP() > jobok.get(j).getP())
				{
					tempJob = jobok.get(i);
					jobok.set(i, jobok.get(j));
					jobok.set(j, tempJob);
                }
			}
		}

		//fiktív jobok hozzáadása -1es ID-vel, és 0 idővel ha szükséges
		if(N%M == 0)
		{
			System.out.println("Nincs szükség fiktív munkára.");
		}
		else
		{
			fiktiv = M - N%M;
			System.out.println(fiktiv + " darab fiktív munkára van szükség.");
			for(i=0; i<fiktiv; i++)
			{
				jobok.add(0, new Job(-1, 0));
				N++;
			}
		}
		
		//munkák kiosztása a gépekre
		csoportSzam = N/M;
		db = N/csoportSzam;
		for(i=0; i<M; i++)
		{
			for(j=0; j<csoportSzam; j++)
			{
				Job job = jobok.get(i + db * j);//db*j megadja a csoport első elemének sorszámát, amit a gép sorszámával el kell tolni
				gepek[i].addJob(job);
			}
			System.out.println(gepek[i] + "\n");
		}

		//szumma C kiszámolása
		for(i=0; i<N; i++)
		{
			szumC += jobok.get(i).getC();
		}
		System.out.println("szumma c: " + szumC);
	}
}
