/*
feladat:
F2/perm/Cmax
*/

package gyak_4;

/**
 *
 * @author Simon Csaba
 */
import java.util.ArrayList;

public class Main_4
{
	public static void main(String [] args)
	{
		int N = 10; //munkák száma
		int maxIdoA = 100;
		int maxIdoB = 100;
		
		ArrayList<Job> jobok = new ArrayList<Job>();

		Job[] Sopt = new Job[N];
		int tmpA, tmpB;
		int min, minJob = -1; //minimum idő, és job sorszáma
		GepEnum gep = null; //A vagy B gépen van a minimum
		int eleje = 0; //tömb elején hány elem van
		int vege = 0; //tömb végén hány elem van

		//jobok létrehozása
		for(int i=0; i<N; i++)
		{
			tmpA = (int)((maxIdoA - 1)*Math.random())+1;
			tmpB = (int)((maxIdoB - 1)*Math.random())+1;
			Job job = new Job(i, tmpA, tmpB);

			//jobok.addElement(job);
			jobok.add(i, job);
		}

		//Johnson algoritmus
		for(int i=0; i<N; i++)
		{
			//megnézi hogy hol van a minimum
			min = maxIdoA + maxIdoB;
			for(int j=0; j<N-i; j++)
			{
				Job tmpJob = jobok.get(j);
				if(tmpJob.getA()<=min)
				{
					min = tmpJob.getA();
					minJob = j;
					gep = GepEnum.A;
				}
				if(tmpJob.getB()<=min)
				{
					min = tmpJob.getB();
					minJob = j;
					gep = GepEnum.B;
				}
			}

			//áthelyezi a tömbbe, majd törli a listából
			if(gep == GepEnum.A)
			{
				Job tmpJob = jobok.get(minJob);
				Sopt[eleje] = tmpJob;
				eleje ++;
				jobok.remove(minJob);
			}
			else
			{
				Job tmpJob = jobok.get(minJob);
				Sopt[N-1-vege] = tmpJob;
				vege ++;
				jobok.remove(minJob);
			}
		}

		//Gannt
		Sopt[0].setStA(0); //első job az A gépen 0-nál kezd
		Sopt[0].setEtA(Sopt[0].getA()); //... és az A gépen töltött idő után végez
		
		Sopt[0].setStB(Sopt[0].getEtA()); //a B gépen az A befejezésekor kezd
		Sopt[0].setEtB(Sopt[0].getStB() + Sopt[0].getB());
		

		for(int i=1; i<N; i++)
		{
			Sopt[i].setStA(Sopt[i-1].getEtA());
			Sopt[i].setEtA(Sopt[i].getStA() + Sopt[i].getA());

			if(Sopt[i].getEtA() > Sopt[i-1].getEtB())
			{
				Sopt[i].setStB(Sopt[i].getEtA());
			}
			else
			{
				Sopt[i].setStB(Sopt[i-1].getEtB());
			}
			Sopt[i].setEtB(Sopt[i].getStB() + Sopt[i].getB());
		}

		System.out.println("Optimális sorrendben lévő jobok adatai:");
		for(int i=0; i<N; i++)
		{
			System.out.println(Sopt[i]);
		}
	}
}