/*
feladat:
1/Di/Lmax
*/

package gyak_1;

/**
 *
 * @author Simon Csaba
 */
public class Main_1
{
	public static void main(String[] args)
	{
		//változók
		int N = 6; //munkák száma
		int i, j, et; //segédváltozók
		int Dmax = 10;
		int Pmax = 10;
		int Lmax = 0; //L maximuma
		Job temp = null; //ideiglenes változó
		Job job = null; //ideiglenes változó

		//tömb létrehozása
		Job[] jobok = new Job[N];

		//tömb feltöltése véletlen számokkal
		for(i=0; i<N; i++)
		{
			int p = (int)((Pmax-1) * Math.random() +1); //1-Pmaxig véletlen szám generálása
			int d = (int)((Dmax-1) * Math.random() +1); //1-Dmaxig véletlen szám generálása
			jobok[i] = new Job(i, p, d);
		}

		//jobok sorbarendezése D alapján
		for(i=0; i<N-1; i++)
		{
			for (j = i+1; j<N; j++ )
			{
				if(jobok[i].getD() > jobok[j].getD())
				{
					temp = jobok[i];
					jobok[i] = jobok[j];
					jobok[j] = temp;
                }
			}
		}

		//jobok adatainak kiszámítása, Lmax meghatározása
		job = jobok[0];

		job.setSt(0);
		job.setEt(job.getP());
		job.setL( job.getEt() - job.getD() );
		Lmax = job.getL(); //ezt vesszük a legnagyobbnak, ha nem ez az később kiderül



		for(i=1; i<N; i++)
		{
			et = job.getEt(); //előző job befejezési ideje
			job = jobok[i];
			job.setSt(et);
			job.setEt(et + job.getP());
			job.setL(job.getEt() - job.getD());

			if(job.getL() > Lmax)
			{
				Lmax = job.getL();
			}
		}

		System.out.println("optimális sorrend:");
		for(i=0; i<N; i++)
		{
			System.out.println((i+1) + ". munka:\t job " + jobok[i].getId());
		}

		System.out.println("\nLmax: " + Lmax);

		System.out.println("\njobok időadatai:");
		for(i=0; i<N; i++)
		{
			System.out.println(jobok[i]);
		}
	}
}