/*
feladat:
P//Cmax
*/

package gyak_3;

/**
 *
 * @author Simon Csaba
 */
public class Main_3
{
	public static void main(String[] args)
	{
		int N = 10;//munkák száma
		int M = 3;//gépek száma
		int maxido = 20;

		Job [] jobok = new Job[N];
		Gep [] gepek = new Gep[M];

		//jobok létrehozása
		for(int i=0; i<N; i++)
		{
			int tmp = (int)((maxido-1)*Math.random()+1);
			jobok[i] = new Job(i, tmp);
		}

		//gépek létrehozása
		for(int i=0; i<M; i++)
		{
			gepek[i] = new Gep(i, 0, N);
		}

		//jobok sorbarendezése P szerint
		for(int i=0; i<N; i++)
		{
			for(int j=i+1; j<N; j++)
			{
				if(jobok[i].getP() < jobok[j].getP())
				{
					Job tmp = jobok[i];
					jobok[i] = jobok[j];
					jobok[j] = tmp;
				}
			}
		}

		System.out.println("Sorbarendezett jobok:");
		for(int i=0; i<N; i++)
		{
			System.out.println(jobok[i]);
		}

		//első M munka berakása
		for(int i=0; i<M; i++)
		{
			gepek[i].addmunka(jobok[i]);
		}

		//M+1-edik munkától a többi berakása
		for(int i=M; i<N; i++)
		{
			int min = gepek[0].getIdo();
			int gepsorszam = 0;

			for(int j=0; j<M; j++)
			{
				if(gepek[j].getIdo()<min)
				{
					min = gepek[j].getIdo();
					gepsorszam = j;
				}
			}
			gepek[gepsorszam].addmunka(jobok[i]);
		}

		//gépek adatainak kiírása
		System.out.println("Gépek adatai:");
		for(int i=0; i<M; i++)
		{
			System.out.println(gepek[i]);
		}
	}
}